!function(){ // IIFE declaration

  // make screen smol (9:16, 270x480)
  //actually im making it 287x480 (9.566:16) because facts dont care about your feelings
  let old_YF_updateRes = Yanfly.updateResolution
  Yanfly.updateResolution = function() {
    //this is kind of stupid but i dont want to end up overwriting any configs
    Yanfly.Param.ScreenWidth = 287 * (ConfigManager.screenResolution + 1)
    Yanfly.Param.ScreenHeight = 480 * (ConfigManager.screenResolution + 1)
    SceneManager._screenWidth  = Yanfly.Param.ScreenWidth
    SceneManager._screenHeight = Yanfly.Param.ScreenHeight
    Graphics.width  = 287
    Graphics.height = 480

    old_YF_updateRes.call(this)
  }
  let old_OM_menu_optCommand = Window_OmoMenuOptionsGeneral.prototype.processOptionCommand
  Window_OmoMenuOptionsGeneral.prototype.processOptionCommand = function() {
    //quirky fix to ensure configmanager reports the correct resolution multiplier BEFORE updating the resolution
    let index = this.index()
    let entry = this._optionsList[index]
    if (index === 0) {
        ConfigManager.screenResolution = entry.index
    }
    old_OM_menu_optCommand.call(this)
  }
  let old_OTS_createMenuSprites = Scene_OmoriTitleScreen.prototype.createTitleSprites
  Scene_OmoriTitleScreen.prototype.createTitleSprites = function() {
    old_OTS_createMenuSprites.call(this)
    //wait why did i pu
    this._titleTextContainerSprite.x = 5;

  }
  let old_OTS_start = Scene_OmoriTitleScreen.prototype.start
  Scene_OmoriTitleScreen.prototype.start = function() {
    old_OTS_start.call(this)
    this._titleTextContainerSprite.y = 15;

    Input.keyMapper[79] = "oKey"

    this._titleCommands[0].x = 108
    this._titleCommands[0].y = Graphics.height - 80
    this._titleCommands[1].x = 236
    this._titleCommands[1].y = 447

    this._omoriSprite.filters = []
    this._glitchSettings.active = true
    AudioManager.playBgm({name: "user_title", pan: 0, pitch: 100, volume: 70}, 0)
    this.addBSprite(270, 40, 0.08, 0.04, 3, 0.5, 0, 30)
  }
  let old_OTS_init = Scene_OmoriTitleScreen.prototype.initialize
  Scene_OmoriTitleScreen.prototype.initialize = function() {
    old_OTS_init.call(this)
    this.groundSpeedX = 1.3
    this.scrollSpeedX = 0.5
    this.scrollSpeedY = 0.45
    this._goToNext = false
    this._bgAnim = []
    this._birdSprites = []
  }
  Window_OmoTitleScreenBox.prototype.initialize = function(text = '') {
    this._text = text;
    Window_Selectable.prototype.initialize.call(this, 0, 0, 160 - 30, 30);
    let themesOffset = text === "THEMES" ? 5 : 0
    this.width = themesOffset + this.textWidth(this._text) + this.standardPadding() * 6;
    this.createContents();
    this.opacity = 0;
    this.contentsOpacity = 0;
    this._enabled = true;
    this.refresh();
    this.activate();
  };
  Scene_OmoriTitleScreen.prototype.createTitleCommands = function() {
    this._titleCommands = [];
    var textList = ['PLAY', 'X2']
    for (var i = 0; i < textList.length; i++) {
      var text = textList[i];
      var win = new Window_OmoTitleScreenBox(text);
      if (i === this._commandIndex) {win.select(0)}
      this._titleCommands[i] = win;
      this.addChild(win)
    };
  };
  let old_OTS_updateCmdInput = Scene_OmoriTitleScreen.prototype.updateCommandInput
  Scene_OmoriTitleScreen.prototype.updateCommandInput = function() {
    if (Input.isTriggered('ok')) {
      if (!this._goToNext) {
        switch (this._commandIndex) {
          case 0: //play
            this.commandStartBirdGame();
            break;
          case 1: // x2 resolution
            AudioManager.playSe({name: "SYS_select", pan: 0, pitch: 100, volume: 90});
            ConfigManager.screenResolution = ConfigManager.screenResolution ? 0 : 1;
            Yanfly.updateResolution()
            ConfigManager.save()
            break;
        }
      }
    } else {
      old_OTS_updateCmdInput.call(this)
    }
  }

  let newSpriteCounter = 100
  let reuseDead = undefined
  let pivotPoint = new PIXI.Point(30,20)

  let mariBitmap = ImageManager.loadBitmap('img/pictures/', 'mb_mari_fa', 0, true)
  let mariBitmap2 = ImageManager.loadBitmap('img/pictures/', 'mb_mari_gh', 0, true)

  Scene_OmoriTitleScreen.prototype.updateBSprites = function() {
    for (let bInd = 0; bInd < this._birdSprites.length; bInd++) {
      const birdSprite = this._birdSprites[bInd]
      if (this._glitchSettings.times === 4) {
        birdSprite.sprite.bitmap = mariBitmap2
      } else if (this._glitchSettings.times === 1) {
        birdSprite.sprite.bitmap = mariBitmap
      }
      if (birdSprite.sprite.pivot.x === 0) {
        birdSprite.sprite.pivot = pivotPoint
      }
      if (this._goToNext) {
        birdSprite.sprite.alpha = Math.max((this._bgAnim.length - 3) / 60, 0)
      }
      birdSprite.dead = birdSprite.dead || birdSprite.sprite.y >= 442
      birdSprite.vy = (birdSprite.vy + birdSprite.gravity) * (birdSprite.sprite.y >= 455 ? 0 : 1)
      birdSprite.sprite.y += birdSprite.vy
      birdSprite.sprite.rotation = deg_to_rad(clamp_num(birdSprite.vy*12, -40, 90))
      if (!birdSprite.dead) {
        let willJump = birdSprite.wF === 1 || ((birdSprite.wF && Math.random()) < birdSprite.wF)
        willJump = willJump && (birdSprite.sprite.y > birdSprite.height - birdSprite.range)
        willJump = willJump || (birdSprite.sprite.y > birdSprite.height + birdSprite.range)
        if (willJump) {
          birdSprite.vy = -birdSprite.jP
        }
      }
      birdSprite.sprite.x -= this.groundSpeedX - (birdSprite.dead ? 0 : (0.6 + birdSprite.sV))
      if (birdSprite.sprite.x < -30) {
        this._birdSprites.splice(bInd, 1)
        bInd--;
        if (!reuseDead) {
          reuseDead = birdSprite
        } else {
          this.removeChild(birdSprite.sprite)
        }
      }
    }
  }
  Scene_OmoriTitleScreen.prototype.addBSprite = function(height = 200, range = 100, gravity = 0.08, wackyFactor = 0.04, jumpPower = 3, scale = 0.5, speedVar = 0, bSpOffset = 400) {
    let newBirdSprite = {
      vy: 0,
      dead:false,
      height:height,
      range:range,
      gravity:gravity,
      wF:wackyFactor,
      sV: speedVar,
      jP: jumpPower
    }
    if (reuseDead !== undefined) {
      newBirdSprite.sprite = reuseDead.sprite
      reuseDead = undefined
    } else {
      newBirdSprite.sprite = new Sprite(mariBitmap)
    }
    newBirdSprite.sprite.scale = new PIXI.Point(scale, scale)
    newBirdSprite.sprite.move(Graphics.width + bSpOffset, newBirdSprite.height)
    this._birdSprites.push(newBirdSprite)
    newBirdSprite.sprite.filterArea = new PIXI.Rectangle(0, 0, Graphics.width, Graphics.height + Math.floor(Graphics.height / 6));
    newBirdSprite.sprite.filters = [this._glitchFilter]
    this.addChildAt(newBirdSprite.sprite, 2)
  }
  let bSAlt = 1
  Scene_OmoriTitleScreen.prototype.bSpriteGenerator = function() {
    newSpriteCounter -= 1;
    if (newSpriteCounter === 0) {
      newSpriteCounter = rand_int(34, 54)
      bSAlt = bSAlt === 1 ? 2 : 1
      this.addBSprite(((rand_int(0,310)/2) * bSAlt) + 100, rand_int(10,50), rand_int(7,10)/100, rand_int(1, 5)/100, rand_int(20,31)/10, rand_int(9,12)/20, 0)
    }
  }
  let kCooldown = 600
  Scene_OmoriTitleScreen.prototype.updateKillInput = function() {
    if (kCooldown >= 0) {
      kCooldown -= 1
    }
    if (Input.isTriggered('oKey')) {
      if (kCooldown < 0) {
        this._glitchSettings.timing = 0
        this._birdSprites.forEach(mS => mS.dead = true);
        kCooldown = 600
      }
    }
  }
  let old_OTS_update = Scene_OmoriTitleScreen.prototype.update
  Scene_OmoriTitleScreen.prototype.update = function() {
    this.updateBSprites()
    this.updateKillInput()
    this.bSpriteGenerator()
    old_OTS_update.call(this)
    let currentSpeedup = this._bgAnim.length === 0 ? 0 : this._bgAnim.pop()
    this.groundSpeedX += currentSpeedup
    this.scrollSpeedX += currentSpeedup

    this._groundSprite2.origin.x += this.groundSpeedX;
    this._backgroundSprite.origin.x += this.scrollSpeedX;
    this._backgroundSprite.origin.y += this.scrollSpeedY;

    if (this._bgAnim.length === 0 && this._goToNext) {
      window.$transitionData = [this._groundSprite2.origin.x, this._backgroundSprite.origin.x, this._backgroundSprite.origin.y, this.groundSpeedX, 0.5+this.scrollSpeedX, -0.5+this.scrollSpeedY]
      SceneManager.push(DGT_birdGame_scene)
    }
  };
  Scene_OmoriTitleScreen.prototype.createBackground = function() {
  	// Create Background Sprite
    this._groundSprite2 = new TilingSprite()
    this._groundSprite2.move(0, Graphics.height - 30, Graphics.width, 30)
    this._groundSprite2.bitmap = ImageManager.loadBitmap('img/pictures/', 'fa_ground', 0, true)

  	this._backgroundSprite = new TilingSprite();
  	this._backgroundSprite.move(0, 0, Graphics.width, Graphics.height);
    this.addChild(this._backgroundSprite);
    this._backgroundSprite.bitmap =   ImageManager.loadParallax('!polaroidBG_FA_day')

    this.addChild(this._groundSprite2)
    /*
    if(this._worldType === 448 || this._worldType === 447 || this._worldType === 449) {this._backgroundSprite.bitmap =   ImageManager.loadParallax('!polaroidBG_FA_day');}
    else if(this._worldType === 446) {
  		var bitmap = new Bitmap(Graphics.width, Graphics.height);
  		bitmap.fillAll('rgba(255, 255, 255, 1)');
  		this._backgroundSprite.bitmap = bitmap;
    }
    else if(this._worldType === 445) {// Red Space
      this._backgroundSprite.bitmap = ImageManager.loadParallax('!parallax_black_space');
    }
    else if(this._worldType === 444) {
  		var bitmap = new Bitmap(Graphics.width, Graphics.height);
  		bitmap.fillAll('rgba(0, 0, 0, 1)');
  		this._backgroundSprite.bitmap = bitmap;
    }
    else if(this._worldType === 0) {
  		var bitmap = new Bitmap(Graphics.width, Graphics.height);
  		bitmap.fillAll('rgba(255, 255, 255, 1)');
  		this._backgroundSprite.bitmap = bitmap;
    }
    */
  };
  Scene_OmoriTitleScreen.prototype.createOmoriSprite = function() {
    // Create Omori Sprite
  	//if (this._worldType != 448) {

      //if (this._worldType === 0 || this._worldType === 446) {
  		//	this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_WS'));
  		//} else if (this._worldType === 444) {
  		//	this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_BS'));
  		//} else if (this._worldType === 445 || this._worldType === 447 || this._worldType === 449) {
      //  this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_RS'));
      //}

      this._omoriSprite = new Sprite(ImageManager.loadPicture('OMO_RS'));

  		this._omoriSprite.anchor.set(0.5, 1)
  		this._omoriSprite.x = Graphics.width / 2;
  		this._omoriSprite.y = Graphics.height;
  		this._omoriSprite.setFrame(0, 0, 0, 0);
  		this._omoriSprite.filters = [this._glitchFilter];

  		this._omoriSprite.visible = false;
  		this._omoriSprite.filterArea = new PIXI.Rectangle(0, 0, Graphics.width, Graphics.height + Math.floor(Graphics.height / 6));
  		this.addChild(this._omoriSprite);
  	//}
  };
  let old_OTS_updateWorldBitmaps = Scene_OmoriTitleScreen.prototype.updateWorldBitmaps
  Scene_OmoriTitleScreen.prototype.updateWorldBitmaps = function(world = this._worldType, temp = false) {
    old_OTS_updateWorldBitmaps.call(this, 447, temp)
  }
  Scene_OmoriTitleScreen.prototype.createVersionText = function() {}
  Scene_OmoriTitleScreen.prototype.createCommandHints = function() {}
  Scene_OmoriTitleScreen.prototype.refreshCommandHints = function() {}
  Scene_OmoriTitleScreen.prototype.createFilters = function() {
    // Create GLitch Filter
    this._glitchFilter = new PIXI.filters.GlitchFilter();
    this._glitchFilter.fillMode = 2;
    this._glitchFilter.slices = 0;
    this._glitchFilter.seed = 0
    // Initialize Glitch Settings
    this._glitchSettings = {timer: 0, timing: NaN, maxTiming: NaN, times: 5, world: 2, active: false}
  };
  let old_titleScreenCreate = Scene_OmoriTitleScreen.prototype.create;
  Scene_OmoriTitleScreen.prototype.create = function() {
      this._canContinue = false
      old_titleScreenCreate.call(this);
  };
  Scene_OmoriTitleScreen.prototype.commandStartBirdGame = function() {
    if (!this._goToNext) {
      AudioManager.playSe({name: "SE_load", pan: 0, pitch: 100, volume: 90});
      this._bgAnim = Array(60).fill(0.45,0)
      this._goToNext = true
    }
  }
}();
